LeetCode 692.前K个高频单词(小根堆) Java

LeetCode 暑期打卡第七周题八
很费解理解的一道题,也是头一次重写集合排序,学习到了…
题目:
给一非空的单词列表,返回前 k 个出现次数最多的单词。

返回的答案应该按单词出现频率由高到低排序。如果不同的单词有相同出现频率,按字母顺序排序。

示例 1:

输入: [“i”, “love”, “leetcode”, “i”, “love”, “coding”], k = 2
输出: [“i”, “love”]
解析: “i” 和 “love” 为出现次数最多的两个单词,均为2次。
注意,按字母顺序 “i” 在 “love” 之前。

示例 2:

输入: [“the”, “day”, “is”, “sunny”, “the”, “the”, “the”, “sunny”, “is”, “is”], k = 4
输出: [“the”, “is”, “sunny”, “day”]
解析: “the”, “is”, “sunny” 和 “day” 是出现次数最多的四个单词,
出现次数依次为 4, 3, 2 和 1 次。

注意:

假定 k 总为有效值, 1 ≤ k ≤ 集合元素数。
输入的单词均由小写字母组成。

扩展练习:

尝试以 O(n log k) 时间复杂度和 O(n) 空间复杂度解决。

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/top-k-frequent-words
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。


方法一:排序暴力
本题暴力可以用排序法解决,时间复杂度 O (N * log2N)
代码来自LeetCode官方题解:

class Solution {
        public List<String> topKFrequent(String[] words, int k) {
            Map<String, Integer> count = new HashMap();
            for (String word : words) {
                count.put(word, count.getOrDefault(word, 0) + 1);
            }
            List<String> candidates = new ArrayList(count.keySet());
            Collections.sort(candidates, (w1, w2) -> count.get(w1).equals(count.get(w2)) ?
                    w1.compareTo(w2) : count.get(w2) - count.get(w1));

            return candidates.subList(0, k);
        }
    }

时间复杂度 O (N * log2N)


方法二:小根堆
本题最优解是使用小根堆解决,又学习到新的算法。
在优先队列中排序记录单词出现次数Map中的大小顺序,然后逆向输出
这里也给出规律,如果类似本题题意找出出现次数最多的单词就用小根堆,出现次数最少的单词则用大根堆。
(如果本题使用大根堆会将全部的单词全部放进队列中,复杂度将达到N * log2N ,不符合题意)

public List<String> topKFrequent(String[] words, int k) {
        ArrayList<String> ans = new ArrayList<>();
        Map<String, Integer> map = new HashMap<>();
        int n = words.length;
        for (int i = 0; i < n; i++) {
            map.put(words[i], map.getOrDefault(words[i], 0) + 1);
        }

        PriorityQueue<Map.Entry<String, Integer>> pp = new PriorityQueue<>((x1, x2) -> {
            if (x1.getValue() < x2.getValue()) return 1;
            else if (x1.getValue() > x2.getValue()) return -1;
            else return x1.getKey().compareTo(x2.getKey());
        });

        for (Map.Entry<String, Integer> i : map.entrySet()) pp.add(i);

        for (int i = 0; i < k; i++) {
            String temp = pp.peek().getKey();
            ans.add(temp);
            pp.poll();
        }
        return ans;
    }

时间复杂度 O (N * log2k)


对于代码中的Comparable的compareTo这次学习还是稍微有点抽象,之后会对此更深入学习研究。

PriorityQueue<Map.Entry<String, Integer>> pp = new PriorityQueue<>((x1, x2) -> {
            if (x1.getValue() < x2.getValue()) return 1;
            else if (x1.getValue() > x2.getValue()) return -1;
            else return x1.getKey().compareTo(x2.getKey());
        });

望指教!

刷题一刻不能偷懒!!!

你可能感兴趣的:(数据结构)